# HG changeset patch
# Node ID 0ff8b619844ccefc8549ea711b985bcfa86645eb
# Parent  f80f044d734cbbb709c37307917e8c6508cf85d3
diff --git a/pidgin/meson.build b/pidgin/meson.build
--- a/pidgin/meson.build
+++ b/pidgin/meson.build
@@ -34,6 +34,7 @@
 	'pidginnotifiable.c',
 	'pidginnotification.c',
 	'pidginnotificationaddcontact.c',
+	'pidginnotificationauthorizationrequest.c',
 	'pidginnotificationlink.c',
 	'pidginnotificationlist.c',
 	'pidginpluginsmenu.c',
@@ -82,6 +83,7 @@
 	'pidginnotifiable.h',
 	'pidginnotification.h',
 	'pidginnotificationaddcontact.h',
+	'pidginnotificationauthorizationrequest.h',
 	'pidginnotificationlink.h',
 	'pidginnotificationlist.h',
 	'pidginpluginsmenu.h',
diff --git a/pidgin/pidginnotificationauthorizationrequest.c b/pidgin/pidginnotificationauthorizationrequest.c
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationauthorizationrequest.c
@@ -0,0 +1,179 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#include <glib/gi18n-lib.h>
+
+#include <purple.h>
+
+#include "pidgin/pidginnotificationauthorizationrequest.h"
+
+struct _PidginNotificationAuthorizationRequest {
+	PidginNotification parent;
+};
+
+G_DEFINE_FINAL_TYPE(PidginNotificationAuthorizationRequest,
+                    pidgin_notification_authorization_request,
+                    PIDGIN_TYPE_NOTIFICATION)
+
+/******************************************************************************
+ * Callbacks
+ *****************************************************************************/
+static void
+pidgin_notification_authorization_request_create_dm_cb(GObject *self,
+                                                       GAsyncResult *result,
+                                                       G_GNUC_UNUSED gpointer data)
+{
+	PurpleContact *contact = PURPLE_CONTACT(self);
+	PurpleConversation *conversation = NULL;
+	GError *error = NULL;
+
+	conversation = purple_contact_create_dm_finish(contact, result, &error);
+	if(error != NULL) {
+		g_warning("failed to create dm for %s: %s",
+		          purple_contact_info_get_name_for_display(PURPLE_CONTACT_INFO(contact)),
+		          error->message);
+
+		g_clear_error(&error);
+		g_clear_object(&conversation);
+
+		return;
+	}
+
+	if(PURPLE_IS_CONVERSATION(conversation)) {
+		purple_conversation_present(conversation);
+	}
+
+	g_clear_object(&conversation);
+}
+
+/******************************************************************************
+ * Actions
+ *****************************************************************************/
+static void
+pidgin_notification_authorization_request_accept(GtkWidget *self,
+                                                 G_GNUC_UNUSED const char *action_name,
+                                                 G_GNUC_UNUSED GVariant *parameter)
+{
+	PidginNotification *pidgin_notification = PIDGIN_NOTIFICATION(self);
+	PurpleAuthorizationRequest *request = NULL;
+	PurpleNotification *purple_notification = NULL;
+	PurpleNotificationAuthorizationRequest *notification_authorization_request = NULL;
+
+	purple_notification = pidgin_notification_get_notification(pidgin_notification);
+	notification_authorization_request = PURPLE_NOTIFICATION_AUTHORIZATION_REQUEST(purple_notification);
+	request = purple_notification_authorization_request_get_request(notification_authorization_request);
+
+	purple_authorization_request_accept(request);
+
+	purple_notification_delete(purple_notification);
+}
+
+static void
+pidgin_notification_authorization_request_message(GtkWidget *self,
+                                                  G_GNUC_UNUSED const char *action_name,
+                                                  G_GNUC_UNUSED GVariant *parameter)
+{
+	PidginNotification *pidgin_notification = PIDGIN_NOTIFICATION(self);
+	PurpleNotification *purple_notification = NULL;
+	PurpleNotificationAuthorizationRequest *notification_authorization_request = NULL;
+	PurpleAuthorizationRequest *request = NULL;
+	PurpleContact *contact = NULL;
+	PurpleConversation *conversation = NULL;
+
+	purple_notification = pidgin_notification_get_notification(pidgin_notification);
+	notification_authorization_request = PURPLE_NOTIFICATION_AUTHORIZATION_REQUEST(purple_notification);
+	request = purple_notification_authorization_request_get_request(notification_authorization_request);
+	contact = purple_authorization_request_get_contact(request);
+
+	conversation = purple_contact_find_dm(contact);
+	if(PURPLE_IS_CONVERSATION(conversation)) {
+		purple_conversation_present(conversation);
+	} else {
+		purple_contact_create_dm_async(contact, NULL,
+		                               pidgin_notification_authorization_request_create_dm_cb,
+		                               NULL);
+	}
+}
+
+static void
+pidgin_notification_authorization_request_deny(GtkWidget *self,
+                                               G_GNUC_UNUSED const char *action_name,
+                                               G_GNUC_UNUSED GVariant *parameter)
+{
+	PidginNotification *pidgin_notification = PIDGIN_NOTIFICATION(self);
+	PurpleAuthorizationRequest *request = NULL;
+	PurpleNotification *purple_notification = NULL;
+	PurpleNotificationAuthorizationRequest *notification_authorization_request = NULL;
+
+	purple_notification = pidgin_notification_get_notification(pidgin_notification);
+	notification_authorization_request = PURPLE_NOTIFICATION_AUTHORIZATION_REQUEST(purple_notification);
+	request = purple_notification_authorization_request_get_request(notification_authorization_request);
+
+	purple_authorization_request_deny(request, NULL);
+
+	purple_notification_delete(purple_notification);
+}
+
+/******************************************************************************
+ * GObject Implementation
+ *****************************************************************************/
+static void
+pidgin_notification_authorization_request_init(PidginNotificationAuthorizationRequest *notification)
+{
+	gtk_widget_init_template(GTK_WIDGET(notification));
+}
+
+static void
+pidgin_notification_authorization_request_class_init(PidginNotificationAuthorizationRequestClass *klass)
+{
+	GtkWidgetClass *widget_class = GTK_WIDGET_CLASS(klass);
+
+	gtk_widget_class_set_template_from_resource(
+	    widget_class,
+	    "/im/pidgin/Pidgin3/notificationauthorizationrequest.ui"
+	);
+
+	gtk_widget_class_install_action(widget_class, "notification.accept",
+	                                NULL,
+	                                pidgin_notification_authorization_request_accept);
+	gtk_widget_class_install_action(widget_class, "notification.message",
+	                                NULL,
+	                                pidgin_notification_authorization_request_message);
+	gtk_widget_class_install_action(widget_class, "notification.deny",
+	                                NULL,
+	                                pidgin_notification_authorization_request_deny);
+}
+
+/******************************************************************************
+ * API
+ *****************************************************************************/
+GtkWidget *
+pidgin_notification_authorization_request_new(PurpleNotificationAuthorizationRequest *notification)
+{
+	g_return_val_if_fail(PURPLE_IS_NOTIFICATION_AUTHORIZATION_REQUEST(notification),
+	                     NULL);
+
+	return g_object_new(
+		PIDGIN_TYPE_NOTIFICATION_AUTHORIZATION_REQUEST,
+		"notification", notification,
+		NULL);
+}
diff --git a/pidgin/pidginnotificationauthorizationrequest.h b/pidgin/pidginnotificationauthorizationrequest.h
new file mode 100644
--- /dev/null
+++ b/pidgin/pidginnotificationauthorizationrequest.h
@@ -0,0 +1,76 @@
+/*
+ * Pidgin - Internet Messenger
+ * Copyright (C) Pidgin Developers <devel@pidgin.im>
+ *
+ * Pidgin is the legal property of its developers, whose names are too numerous
+ * to list here.  Please refer to the COPYRIGHT file distributed with this
+ * source distribution.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <https://www.gnu.org/licenses/>.
+ */
+
+#if !defined(PIDGIN_GLOBAL_HEADER_INSIDE) && !defined(PIDGIN_COMPILATION)
+# error "only <pidgin.h> may be included directly"
+#endif
+
+#ifndef PIDGIN_NOTIFICATION_AUTHORIZATION_REQUEST_H
+#define PIDGIN_NOTIFICATION_AUTHORIZATION_REQUEST_H
+
+#include <glib.h>
+
+#include <gtk/gtk.h>
+
+#include <purple.h>
+
+#include "pidginnotification.h"
+#include "pidginversion.h"
+
+G_BEGIN_DECLS
+
+/**
+ * PidginNotificationAuthorizationRequest:
+ *
+ * #PidginNotificationAuthorizationRequest is a widget that displays
+ * notifications from [class@Purple.NotificationManager] for
+ * [class@Purple.AuthorizationRequest].
+ *
+ * Since: 3.0
+ */
+
+#define PIDGIN_TYPE_NOTIFICATION_AUTHORIZATION_REQUEST (pidgin_notification_authorization_request_get_type())
+
+PIDGIN_AVAILABLE_IN_3_0
+G_DECLARE_FINAL_TYPE(PidginNotificationAuthorizationRequest,
+                     pidgin_notification_authorization_request,
+                     PIDGIN, NOTIFICATION_AUTHORIZATION_REQUEST,
+                     PidginNotification)
+
+/**
+ * pidgin_notification_authorization_request_new:
+ * @notification: A [class@Purple.NotificationAuthorizationRequest] to display.
+ *
+ * Creates a new #PidginNotificationAuthorizationRequest instance that will
+ * display @notification.
+ *
+ * Returns: (transfer full): The new #PidginNotificationAuthorizationRequest
+ *          instance.
+ *
+ * Since: 3.0
+ */
+PIDGIN_AVAILABLE_IN_3_0
+GtkWidget *pidgin_notification_authorization_request_new(PurpleNotificationAuthorizationRequest *notification);
+
+G_END_DECLS
+
+#endif /* PIDGIN_NOTIFICATION_AUTHORIZATION_REQUEST_H */
diff --git a/pidgin/pidginnotificationlist.c b/pidgin/pidginnotificationlist.c
--- a/pidgin/pidginnotificationlist.c
+++ b/pidgin/pidginnotificationlist.c
@@ -29,6 +29,7 @@
 #include "pidginnotifiable.h"
 #include "pidginnotification.h"
 #include "pidginnotificationaddcontact.h"
+#include "pidginnotificationauthorizationrequest.h"
 #include "pidginnotificationlink.h"
 
 enum {
@@ -106,6 +107,11 @@
 
 	if(PURPLE_IS_NOTIFICATION_ADD_CONTACT(notification)) {
 		widget = pidgin_notification_add_contact_new(notification);
+	} else if(PURPLE_IS_NOTIFICATION_AUTHORIZATION_REQUEST(notification)) {
+		PurpleNotificationAuthorizationRequest *request = NULL;
+
+		request = PURPLE_NOTIFICATION_AUTHORIZATION_REQUEST(notification);
+		widget = pidgin_notification_authorization_request_new(request);
 	} else if(PURPLE_IS_NOTIFICATION_LINK(notification)) {
 		widget = pidgin_notification_link_new(notification);
 	} else {
diff --git a/pidgin/resources/notificationauthorizationrequest.ui b/pidgin/resources/notificationauthorizationrequest.ui
new file mode 100644
--- /dev/null
+++ b/pidgin/resources/notificationauthorizationrequest.ui
@@ -0,0 +1,70 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+Pidgin - Internet Messenger
+Copyright (C) Pidgin Developers <devel@pidgin.im>
+
+This program is free software; you can redistribute it and/or
+modify it under the terms of the GNU General Public License
+as published by the Free Software Foundation; either version 2
+of the License, or (at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, see <https://www.gnu.org/licenses/>.
+
+-->
+<interface>
+  <requires lib="gtk" version="4.0"/>
+  <!-- interface-license-type gplv2 -->
+  <!-- interface-name Pidgin -->
+  <!-- interface-description Internet Messenger -->
+  <!-- interface-copyright Pidgin Developers <devel@pidgin.im> -->
+  <template class="PidginNotificationAuthorizationRequest" parent="PidginNotification">
+    <property name="child">
+      <object class="GtkBox">
+        <property name="orientation">horizontal</property>
+        <property name="spacing">6</property>
+        <child>
+          <object class="GtkButton">
+            <property name="label" translatable="1">Accept</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">notification.accept</property>
+            <style>
+              <class name="suggested-action"/>
+            </style>
+          </object>
+        </child>
+        <child>
+          <object class="GtkButton">
+            <property name="label" translatable="1">Message</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">notification.message</property>
+          </object>
+        </child>
+        <child>
+          <object class="GtkButton">
+            <property name="label" translatable="1">Deny</property>
+            <property name="focusable">1</property>
+            <property name="receives-default">1</property>
+            <property name="halign">center</property>
+            <property name="valign">center</property>
+            <property name="action-name">notification.deny</property>
+            <style>
+              <class name="destructive-action"/>
+            </style>
+          </object>
+        </child>
+      </object>
+    </property>
+  </template>
+</interface>
diff --git a/pidgin/resources/pidgin.gresource.xml b/pidgin/resources/pidgin.gresource.xml
--- a/pidgin/resources/pidgin.gresource.xml
+++ b/pidgin/resources/pidgin.gresource.xml
@@ -37,6 +37,7 @@
     <file compressed="true" preprocess="xml-stripblanks">infopane.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notification.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationaddcontact.ui</file>
+    <file compressed="true" preprocess="xml-stripblanks">notificationauthorizationrequest.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationlink.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">notificationlist.ui</file>
     <file compressed="true" preprocess="xml-stripblanks">presenceicon.ui</file>
